"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = exports.idlFactory = void 0;
const idlFactory = ({ IDL }) => {
    const LiveBucketExt__1 = IDL.Record({
        'used_memory': IDL.Nat,
        'canister_id': IDL.Principal,
    });
    const LiveBucketExt = IDL.Record({
        'used_memory': IDL.Nat,
        'canister_id': IDL.Principal,
    });
    const Buckets = IDL.Record({
        'old_buckets': IDL.Vec(IDL.Principal),
        'live_buckets': IDL.Vec(LiveBucketExt),
    });
    const HeaderField = IDL.Tuple(IDL.Text, IDL.Text);
    const HttpRequest = IDL.Record({
        'url': IDL.Text,
        'method': IDL.Text,
        'body': IDL.Vec(IDL.Nat8),
        'headers': IDL.Vec(HeaderField),
    });
    const CallbackToken = IDL.Record({
        'key': IDL.Text,
        'total_index': IDL.Nat,
        'index': IDL.Nat,
    });
    const StreamingCallbackHttpResponse = IDL.Record({
        'token': IDL.Opt(CallbackToken),
        'body': IDL.Vec(IDL.Nat8),
    });
    const StreamStrategy = IDL.Variant({
        'Callback': IDL.Record({
            'token': CallbackToken,
            'callback': IDL.Func([CallbackToken], [StreamingCallbackHttpResponse], ['query']),
        }),
    });
    const HttpResponse = IDL.Record({
        'body': IDL.Vec(IDL.Nat8),
        'headers': IDL.Vec(HeaderField),
        'streaming_strategy': IDL.Opt(StreamStrategy),
        'status_code': IDL.Nat16,
    });
    const StoreArgs = IDL.Record({
        'key': IDL.Text,
        'value': IDL.Vec(IDL.Nat8),
        'total_index': IDL.Nat,
        'file_type': IDL.Text,
        'is_http_open': IDL.Bool,
        'total_size': IDL.Nat64,
        'index': IDL.Nat,
    });
    const Result = IDL.Variant({ 'ok': IDL.Text, 'err': IDL.Text });
    const icsp = IDL.Service({
        'addAdmin': IDL.Func([IDL.Principal], [IDL.Bool], []),
        'changeAdmin': IDL.Func([IDL.Vec(IDL.Principal)], [IDL.Bool], []),
        'change_bucket_admin': IDL.Func([], [IDL.Bool], []),
        'createNewBucket': IDL.Func([], [LiveBucketExt__1], []),
        'getAdmins': IDL.Func([], [IDL.Vec(IDL.Principal)], ['query']),
        'getBucketOfFile': IDL.Func([IDL.Text], [IDL.Opt(IDL.Principal)], ['query']),
        'getBuckets': IDL.Func([], [IDL.Opt(Buckets)], ['query']),
        'getCycleBalance': IDL.Func([], [IDL.Nat], ['query']),
        'http_request': IDL.Func([HttpRequest], [HttpResponse], ['query']),
        'init': IDL.Func([], [IDL.Text], []),
        'store': IDL.Func([StoreArgs], [], []),
        'topUp': IDL.Func([IDL.Nat], [Result], []),
        'topUpBucket': IDL.Func([IDL.Nat], [], []),
        'wallet_receive': IDL.Func([], [IDL.Nat], []),
    });
    return icsp;
};
exports.idlFactory = idlFactory;
const init = ({ IDL }) => { return []; };
exports.init = init;
