import type { Principal } from '@dfinity/principal';
import type { ActorMethod } from '@dfinity/agent';
export interface Buckets {
    'old_buckets': Array<Principal>;
    'live_buckets': Array<LiveBucketExt>;
}
export interface CallbackToken {
    'key': string;
    'total_index': bigint;
    'index': bigint;
}
export declare type HeaderField = [string, string];
export interface HttpRequest {
    'url': string;
    'method': string;
    'body': Array<number>;
    'headers': Array<HeaderField>;
}
export interface HttpResponse {
    'body': Array<number>;
    'headers': Array<HeaderField>;
    'streaming_strategy': [] | [StreamStrategy];
    'status_code': number;
}
export interface LiveBucketExt {
    'used_memory': bigint;
    'canister_id': Principal;
}
export interface LiveBucketExt__1 {
    'used_memory': bigint;
    'canister_id': Principal;
}
export declare type Result = {
    'ok': string;
} | {
    'err': string;
};
export interface StoreArgs {
    'key': string;
    'value': Array<number> | Uint8Array;
    'total_index': bigint;
    'file_type': string;
    'is_http_open': boolean;
    'total_size': bigint;
    'index': bigint;
}
export declare type StreamStrategy = {
    'Callback': {
        'token': CallbackToken;
        'callback': [Principal, string];
    };
};
export interface StreamingCallbackHttpResponse {
    'token': [] | [CallbackToken];
    'body': Array<number>;
}
export interface icsp {
    'addAdmin': ActorMethod<[Principal], boolean>;
    'changeAdmin': ActorMethod<[Array<Principal>], boolean>;
    'change_bucket_admin': ActorMethod<[], boolean>;
    'createNewBucket': ActorMethod<[], LiveBucketExt__1>;
    'getAdmins': ActorMethod<[], Array<Principal>>;
    'getBucketOfFile': ActorMethod<[string], [] | [Principal]>;
    'getBuckets': ActorMethod<[], [] | [Buckets]>;
    'getCycleBalance': ActorMethod<[], bigint>;
    'http_request': ActorMethod<[HttpRequest], HttpResponse>;
    'init': ActorMethod<[], string>;
    'store': ActorMethod<[StoreArgs], undefined>;
    'topUp': ActorMethod<[bigint], Result>;
    'topUpBucket': ActorMethod<[bigint], undefined>;
    'wallet_receive': ActorMethod<[], bigint>;
}
export interface _SERVICE extends icsp {
}
