import { ActorMethod, ActorSubclass, HttpAgent } from "@dfinity/agent";
import { getBucketOfFileRes, getBucketsRes } from "../types";
export declare class ICSP {
    private readonly agent;
    private readonly icspCanisterId;
    private readonly ICSPActor;
    constructor(icspCanisterId: string, agent: HttpAgent);
    getBucketActor(canisterId: string): Promise<ActorSubclass<Record<string, ActorMethod<unknown[], unknown>>>>;
    get_cycle_balance(): Promise<bigint>;
    init(): Promise<unknown>;
    get_bucket_of_file(file_key: string): Promise<getBucketOfFileRes>;
    get_icsp_buckets(): Promise<getBucketsRes>;
    store_file(files: File[], is_http_open: boolean): Promise<void>;
    get_file(fileKey: string): Promise<Blob>;
}
