import { ActorMethod, ActorSubclass, HttpAgent } from "@dfinity/agent";
import { createArg, CreateRes, icsp } from "../types";
import { Result, TopUpArgs } from "./did/isp_type";
import { Principal } from "@dfinity/principal";
import { BurnResult } from "./did/xtc_type";
export declare class ISP {
    private readonly canisterId;
    private readonly agent;
    private readonly ISPActor;
    constructor(agent: HttpAgent);
    getXTCActor(): Promise<ActorSubclass<Record<string, ActorMethod<unknown[], unknown>>>>;
    get_user_icsps(): Promise<icsp[]>;
    get_sub_account(): Promise<string>;
    get_icp_balance(): Promise<bigint>;
    transfer_out_icp(accountAdress: string): Promise<bigint>;
    create_icsp(createArgs: createArg): Promise<CreateRes>;
    top_up_icsp_with_xtc(canisterId: Principal, amount: bigint): Promise<BurnResult>;
    top_up_icsp(topUpArg: TopUpArgs): Promise<Result>;
}
